# ExceptHook release 1 by David Bowland
# ./addons/eventscripts/excepthook/excepthook.py

import es
import sys
import time
import traceback


lasthook = sys.excepthook
filepath = es.getAddonPath('excepthook') + '/exceptions.txt'
addondir = str(es.ServerVar('eventscripts_addondir'))


def excepter(*a):
   lines = traceback.format_exception(*a)
   addon = ''

   for line in list(reversed(lines))[1:]:
      addonpath = line.strip().split('"')
      if len(addonpath) > 2:
         addonpath = addonpath[1]
         if addonpath.endswith('.py'):
            currenttime = time.strftime('%x %X')
            addonpath   = addonpath[:~2]
            f = open(addonpath + '_errors.txt', 'a')
            f.writelines([currenttime + '\n'] + lines + ['\n'])
            f.close()

            addon = addonpath.replace('\\', '/').replace(addondir.replace('\\', '/'), '')
            f = open(filepath, 'a')
            f.write(currenttime + ' addon > ' + addon.rsplit('/', 1)[0][1:] + '\n\n')
            f.close()
            break

   lasthook(*a)

sys.excepthook = excepter


def unload():
   sys.excepthook = lasthook